//1999 Cristi Cuturicu
#include "Definicje_sprzet.h"

//#pragma hdrstop
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "GPIO_procedury.h"
#include "Katalogi_SD.h"
#include "datatype.h"


struct Parametry_JPG
{
 	char ile_pikseli_Vert_pola;
	char ile_pikseli_Hor_pola;
	char *p_bufor_YUV_pola;
	int numer_konwertowanego_pasa;
	int numer_konwertowanego_pola;
	int image_width;
	int image_height;
	char piksel_PO6030_ile_bajtow;
}parametry_jpg;

char bufor_YUV_pola[200];		

static struct APP0infotype {
		WORD marker;// = 0xFFE0
		WORD length; // = 16 for usual JPEG, no thumbnail
		BYTE JFIFsignature[5]; // = "JFIF",'\0'
		BYTE versionhi; // 1
		BYTE versionlo; // 1
		BYTE xyunits;   // 0 = no units, normal density
		WORD xdensity;  // 1
		WORD ydensity;  // 1
		BYTE thumbnwidth; // 0
		BYTE thumbnheight; // 0
} APP0info/*={0xFFE0,16,'J','F','I','F',0,1,1,0,1,1,0,0}*/;

static struct  SOF0infotype {
		WORD marker; // = 0xFFC0
		WORD length; // = 17 for a truecolor YCbCr JPG
		BYTE precision ;// Should be 8: 8 bits/sample
		WORD height ;
		WORD width;
		BYTE nrofcomponents;//Should be 3: We encode a truecolor JPG
		BYTE IdY;  // = 1
		BYTE HVY; // sampling factors for Y (bit 0-3 vert., 4-7 hor.)
		BYTE QTY;  // Quantization Table number for Y = 0
		BYTE IdCb; // = 2
		BYTE HVCb;
		BYTE QTCb; // 1
		BYTE IdCr; // = 3
		BYTE HVCr;
		BYTE QTCr; // Normally equal to QTCb = 1
} SOF0info = { 0xFFC0,17,8,0,0,3,1,0x11,0,2,0x11,1,3,0x11,1};
// Default sampling factors are 1,1 for every image component: No downsampling

static struct DQTinfotype {
		 WORD marker;  // = 0xFFDB
		 WORD length;  // = 132
		 BYTE QTYinfo;// = 0:  bit 0..3: number of QT = 0 (table for Y)
				  //       bit 4..7: precision of QT, 0 = 8 bit
		 BYTE Ytable[64];		
		 BYTE QTCbinfo; // = 1 (quantization table for Cb,Cr}
		 BYTE Cbtable[64];   
		   } DQTinfo;
// Ytable from DQTinfo should be equal to a scaled and zizag reordered version
// of the table which can be found in "tables.h": std_luminance_qt
// Cbtable , similar = std_chrominance_qt
// We'll init them in the program using set_DQTinfo function

static struct DHTinfotype {
		 WORD marker;  // = 0xFFC4
		 WORD length;  //0x01A2
		 BYTE HTYDCinfo; // bit 0..3: number of HT (0..3), for Y =0
			  //bit 4  :type of HT, 0 = DC table,1 = AC table
				//bit 5..7: not used, must be 0
		 BYTE YDC_nrcodes[16]; //at index i = nr of codes with length i	
		 BYTE YDC_values[12];												
		 BYTE HTYACinfo; // = 0x10
		 BYTE YAC_nrcodes[16];											
		 BYTE YAC_values[162];//we'll use the standard Huffman tables		
		 BYTE HTCbDCinfo; // = 1
		 BYTE CbDC_nrcodes[16];											
		 BYTE CbDC_values[12];											
		 BYTE HTCbACinfo; //  = 0x11
		 BYTE CbAC_nrcodes[16];											 
		 BYTE CbAC_values[162];											
} DHTinfo;

static struct SOSinfotype {
		 WORD marker;  // = 0xFFDA
		 WORD length; // = 12
		 BYTE nrofcomponents; // Should be 3: truecolor JPG
		 BYTE IdY; //1
		 BYTE HTY; //0 // bits 0..3: AC table (0..3)
				   // bits 4..7: DC table (0..3)
		 BYTE IdCb; //2
		 BYTE HTCb; //0x11
		 BYTE IdCr; //3
		 BYTE HTCr; //0x11
		 BYTE Ss,Se,Bf; // not interesting, they should be 0,63,0
} SOSinfo={0xFFDA,12,3,1,0,2,0x11,3,0x11,0,0x3F,0};

typedef struct { BYTE B,G,R; } colorRGB;
typedef struct { BYTE length;
		 WORD value;} bitstring;

#define  Y(R,G,B) ((BYTE)( (YRtab[(R)]+YGtab[(G)]+YBtab[(B)])>>16 ) - 128)
#define Cb(R,G,B) ((BYTE)( (CbRtab[(R)]+CbGtab[(G)]+CbBtab[(B)])>>16 ) )
#define Cr(R,G,B) ((BYTE)( (CrRtab[(R)]+CrGtab[(G)]+CrBtab[(B)])>>16 ) )

//#define writebyte(b) fputc((b),fp_jpeg_stream)
char *p_buf_wy;
#define writebyte(b) *p_buf_wy=b;p_buf_wy++;
#define writeword(w) writebyte((w)/256);writebyte((w)%256);



const BYTE zigzag[64]={ 0, 1, 5, 6,14,15,27,28,
		  2, 4, 7,13,16,26,29,42,
		  3, 8,12,17,25,30,41,43,
		  9,11,18,24,31,40,44,53,
		 10,19,23,32,39,45,52,54,
		 20,22,33,38,46,51,55,60,
		 21,34,37,47,50,56,59,61,
		 35,36,48,49,57,58,62,63 };

  /* These are the sample quantization tables given in JPEG spec section K.1.
	The spec says that the values given produce "good" quality, and
	when divided by 2, "very good" quality.*/
const BYTE std_luminance_qt[64] = {
	16,  11,  10,  16,  24,  40,  51,  61,
	12,  12,  14,  19,  26,  58,  60,  55,
	14,  13,  16,  24,  40,  57,  69,  56,
	14,  17,  22,  29,  51,  87,  80,  62,
	18,  22,  37,  56,  68, 109, 103,  77,
	24,  35,  55,  64,  81, 104, 113,  92,
	49,  64,  78,  87, 103, 121, 120, 101,
	72,  92,  95,  98, 112, 100, 103,  99
  };
const BYTE std_chrominance_qt[64] = {
	17,  18,  24,  47,  99,  99,  99,  99,
	18,  21,  26,  66,  99,  99,  99,  99,
	24,  26,  56,  99,  99,  99,  99,  99,
	47,  66,  99,  99,  99,  99,  99,  99,
	99,  99,  99,  99,  99,  99,  99,  99,
	99,  99,  99,  99,  99,  99,  99,  99,
	99,  99,  99,  99,  99,  99,  99,  99,
	99,  99,  99,  99,  99,  99,  99,  99
  };
// Standard Huffman tables (cf. JPEG standard section K.3) */

const BYTE std_dc_luminance_nrcodes[17]={0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0};
const BYTE std_dc_luminance_values[12]={0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};

const BYTE std_dc_chrominance_nrcodes[17]={0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0};
const BYTE std_dc_chrominance_values[12]={0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};

const BYTE std_ac_luminance_nrcodes[17]={0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,0x7d };
const BYTE std_ac_luminance_values[162]= {
	  0x01, 0x02, 0x03, 0x00, 0x04, 0x11, 0x05, 0x12,
	  0x21, 0x31, 0x41, 0x06, 0x13, 0x51, 0x61, 0x07,
	  0x22, 0x71, 0x14, 0x32, 0x81, 0x91, 0xa1, 0x08,
	  0x23, 0x42, 0xb1, 0xc1, 0x15, 0x52, 0xd1, 0xf0,
	  0x24, 0x33, 0x62, 0x72, 0x82, 0x09, 0x0a, 0x16,
	  0x17, 0x18, 0x19, 0x1a, 0x25, 0x26, 0x27, 0x28,
	  0x29, 0x2a, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39,
	  0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49,
	  0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59,
	  0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69,
	  0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79,
	  0x7a, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
	  0x8a, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98,
	  0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,
	  0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6,
	  0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3, 0xc4, 0xc5,
	  0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2, 0xd3, 0xd4,
	  0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda, 0xe1, 0xe2,
	  0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9, 0xea,
	  0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
	  0xf9, 0xfa };

const BYTE std_ac_chrominance_nrcodes[17]={0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,0x77};
const BYTE std_ac_chrominance_values[162]={
	  0x00, 0x01, 0x02, 0x03, 0x11, 0x04, 0x05, 0x21,
	  0x31, 0x06, 0x12, 0x41, 0x51, 0x07, 0x61, 0x71,
	  0x13, 0x22, 0x32, 0x81, 0x08, 0x14, 0x42, 0x91,
	  0xa1, 0xb1, 0xc1, 0x09, 0x23, 0x33, 0x52, 0xf0,
	  0x15, 0x62, 0x72, 0xd1, 0x0a, 0x16, 0x24, 0x34,
	  0xe1, 0x25, 0xf1, 0x17, 0x18, 0x19, 0x1a, 0x26,
	  0x27, 0x28, 0x29, 0x2a, 0x35, 0x36, 0x37, 0x38,
	  0x39, 0x3a, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48,
	  0x49, 0x4a, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
	  0x59, 0x5a, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68,
	  0x69, 0x6a, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
	  0x79, 0x7a, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
	  0x88, 0x89, 0x8a, 0x92, 0x93, 0x94, 0x95, 0x96,
	  0x97, 0x98, 0x99, 0x9a, 0xa2, 0xa3, 0xa4, 0xa5,
	  0xa6, 0xa7, 0xa8, 0xa9, 0xaa, 0xb2, 0xb3, 0xb4,
	  0xb5, 0xb6, 0xb7, 0xb8, 0xb9, 0xba, 0xc2, 0xc3,
	  0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9, 0xca, 0xd2,
	  0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9, 0xda,
	  0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
	  0xea, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8,
	  0xf9, 0xfa };





static BYTE bytenew=0; // The byte that will be written in the JPG file
static SBYTE bytepos=7; //bit position in the byte we write (bytenew)
			//should be<=7 and >=0
const WORD mask[16]={1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768};

// The Huffman tables we'll use:
static bitstring YDC_HT[12];	
static bitstring CbDC_HT[12];	
static bitstring YAC_HT[256];		 
static bitstring CbAC_HT[256];	

static bitstring konwersja[1];//!!!

//static BYTE *category_alloc;
//static BYTE *category; //Here we'll keep the category of the numbers in range: -32767..32767
//static bitstring *bitcode_alloc;
//static bitstring *bitcode; // their bitcoded representation

//Precalculated tables for a faster YCbCr->RGB transformation
// We use a SDWORD table because we'll scale values by 2^16 and work with integers
//static SDWORD YRtab[256],YGtab[256],YBtab[256];

const SDWORD YRtab[256]={
0,       19595, 39190, 58785, 78380, 97975, 117570, 137165, 156760, 176355, 195950, 215545, 235140, 254735,          //14
274330, 293925, 313520, 333115, 352710, 372305, 391900, 411495, 431090, 450685, 470280, 489875, 509470, 529065,      //14
548660, 568255, 587850, 607445, 627040, 646635, 666230, 685825, 705420, 725015, 744610, 764205, 783800, 803395,      //14
822990, 842585, 862180, 881775, 901370, 920965, 940560, 960155, 979750, 999345, 1018940, 1038535, 1058130, 1077725,  //14
1097320, 1116915, 1136510, 1156105, 1175700, 1195295, 1214890, 1234485, 1254080, 1273675, 1293270, 1312865, 1332460, //13
1352055, 1371650, 1391245, 1410840, 1430435, 1450030, 1469625, 1489220, 1508815, 1528410, 1548005, 1567600, 1587195, //13
1606790, 1626385, 1645980, 1665575, 1685170, 1704765, 1724360, 1743955, 1763550, 1783145, 1802740, 1822335, 1841930, //13
1861525, 1881120, 1900715, 1920310, 1939905, 1959500, 1979095, 1998690, 2018285, 2037880, 2057475, 2077070, 2096665, //13
2116260, 2135855, 2155450, 2175045, 2194640, 2214235, 2233830, 2253425, 2273020, 2292615, 2312210, 2331805, 2351400, //13
2370995, 2390590, 2410185, 2429780, 2449375, 2468970, 2488565, 2508160, 2527755, 2547350, 2566945, 2586540, 2606135, //13
2625730, 2645325, 2664920, 2684515, 2704110, 2723705, 2743300, 2762895, 2782490, 2802085, 2821680, 2841275, 2860870, //13
2880465, 2900060, 2919655, 2939250, 2958845, 2978440, 2998035, 3017630, 3037225, 3056820, 3076415, 3096010, 3115605, //13
3135200, 3154795, 3174390, 3193985, 3213580, 3233175, 3252770, 3272365, 3291960, 3311555, 3331150, 3350745, 3370340, //13
3389935, 3409530, 3429125, 3448720, 3468315, 3487910, 3507505, 3527100, 3546695, 3566290, 3585885, 3605480, 3625075, //13
3644670, 3664265, 3683860, 3703455, 3723050, 3742645, 3762240, 3781835, 3801430, 3821025, 3840620, 3860215, 3879810, //13
3899405, 3919000, 3938595, 3958190, 3977785, 3997380, 4016975, 4036570, 4056165, 4075760, 4095355, 4114950, 4134545, //13
4154140, 4173735, 4193330, 4212925, 4232520, 4252115, 4271710, 4291305, 4310900, 4330495, 4350090, 4369685, 4389280, //13
4408875, 4428470, 4448065, 4467660, 4487255, 4506850, 4526445, 4546040, 4565635, 4585230, 4604825, 4624420, 4644015, //13
4663610, 4683205, 4702800, 4722395, 4741990, 4761585, 4781180, 4800775, 4820370, 4839965, 4859560, 4879155, 4898750, //13
4918345, 4937940, 4957535, 4977130, 4996725};                                                                                  //4

const SDWORD YGtab[256]={
0, 38470, 76940, 115410, 153880, 192350, 230820, 269290, 307760, 346230, 384700, 423170, 461640, 500110,             //14
538580, 577050, 615520, 653990, 692460, 730930, 769400, 807870, 846340, 884810, 923280, 961750, 1000220, 1038690,    //14
1077160, 1115630, 1154100, 1192570, 1231040, 1269510, 1307980, 1346450, 1384920, 1423390, 1461860, 1500330, 1538800, //13
1577270, 1615740, 1654210, 1692680, 1731150, 1769620, 1808090, 1846560, 1885030, 1923500, 1961970, 2000440, 2038910, //13
2077380, 2115850, 2154320, 2192790, 2231260, 2269730, 2308200, 2346670, 2385140, 2423610, 2462080, 2500550, 2539020, //13
2577490, 2615960, 2654430, 2692900, 2731370, 2769840, 2808310, 2846780, 2885250, 2923720, 2962190, 3000660, 3039130, //13
3077600, 3116070, 3154540, 3193010, 3231480, 3269950, 3308420, 3346890, 3385360, 3423830, 3462300, 3500770, 3539240, //13
3577710, 3616180, 3654650, 3693120, 3731590, 3770060, 3808530, 3847000, 3885470, 3923940, 3962410, 4000880, 4039350, //13
4077820, 4116290, 4154760, 4193230, 4231700, 4270170, 4308640, 4347110, 4385580, 4424050, 4462520, 4500990, 4539460, //13
4577930, 4616400, 4654870, 4693340, 4731810, 4770280, 4808750, 4847220, 4885690, 4924160, 4962630, 5001100, 5039570, //13
5078040, 5116510, 5154980, 5193450, 5231920, 5270390, 5308860, 5347330, 5385800, 5424270, 5462740, 5501210, 5539680, //13
5578150, 5616620, 5655090, 5693560, 5732030,                                                                         //5
5770500, 5808970, 5847440, 5885910, 5924380, 5962850, 6001320, 6039790, 6078260, 6116730, 6155200, 6193670, 6232140, //13
6270610, 6309080, 6347550, 6386020, 6424490, 6462960, 6501430, 6539900, 6578370, 6616840, 6655310, 6693780, 6732250, //13
6770720, 6809190, 6847660, 6886130, 6924600, 6963070, 7001540, 7040010, 7078480, 7116950, 7155420, 7193890, 7232360, //13
7270830, 7309300, 7347770, 7386240, 7424710, 7463180, 7501650, 7540120, 7578590, 7617060, 7655530, 7694000, 7732470, //13
7770940, 7809410, 7847880, 7886350, 7924820, 7963290, 8001760, 8040230, 8078700, 8117170, 8155640, 8194110, 8232580, //13
8271050, 8309520, 8347990, 8386460, 8424930, 8463400, 8501870, 8540340, 8578810, 8617280, 8655750, 8694220, 8732690, //13
8771160, 8809630, 8848100, 8886570, 8925040, 8963510, 9001980, 9040450, 9078920, 9117390, 9155860, 9194330, 9232800, //13
9271270, 9309740, 9348210, 9386680, 9425150, 9463620, 9502090, 9540560, 9579030, 9617500, 9655970, 9694440, 9732910, //13
9771380, 9809850};                                                                                                     //2

const SDWORD YBtab[256]={
0, 7471, 14942, 22413, 29884, 37355, 44826, 52297, 59768, 67239, 74710, 82181, 89652, 97123, 104594,                 //15
112065, 119536, 127007, 134478, 141949, 149420, 156891, 164362, 171833, 179304, 186775, 194246, 201717, 209188,      //14
216659, 224130, 231601, 239072, 246543, 254014, 261485, 268956, 276427, 283898, 291369, 298840, 306311, 313782,      //14
321253, 328724, 336195, 343666, 351137, 358608, 366079, 373550, 381021, 388492, 395963, 403434, 410905, 418376,      //14
425847, 433318, 440789, 448260, 455731, 463202, 470673, 478144, 485615, 493086, 500557, 508028, 515499, 522970,      //14
530441, 537912, 545383, 552854, 560325, 567796, 575267, 582738, 590209, 597680, 605151, 612622, 620093, 627564,      //14
635035, 642506, 649977, 657448, 664919, 672390, 679861, 687332, 694803, 702274, 709745, 717216, 724687, 732158,      //14
739629, 747100, 754571, 762042, 769513, 776984, 784455, 791926, 799397, 806868, 814339, 821810, 829281, 836752,      //14
844223, 851694, 859165, 866636, 874107, 881578, 889049, 896520, 903991, 911462, 918933, 926404, 933875, 941346,      //14
948817, 956288, 963759, 971230, 978701, 986172, 993643, 1001114, 1008585, 1016056, 1023527, 1030998, 1038469,        //13
1045940, 1053411, 1060882, 1068353, 1075824, 1083295, 1090766, 1098237, 1105708,                                     //9
1113179, 1120650, 1128121, 1135592, 1143063, 1150534, 1158005, 1165476, 1172947, 1180418, 1187889, 1195360, 1202831, //13
1210302, 1217773, 1225244, 1232715, 1240186, 1247657, 1255128, 1262599, 1270070, 1277541, 1285012, 1292483, 1299954, //13
1307425, 1314896, 1322367, 1329838, 1337309, 1344780, 1352251, 1359722, 1367193, 1374664, 1382135, 1389606, 1397077, //13
1404548, 1412019, 1419490, 1426961, 1434432, 1441903, 1449374, 1456845, 1464316, 1471787, 1479258, 1486729, 1494200, //13
1501671, 1509142, 1516613, 1524084, 1531555, 1539026, 1546497, 1553968, 1561439, 1568910, 1576381, 1583852, 1591323, //13
1598794, 1606265, 1613736, 1621207, 1628678, 1636149, 1643620, 1651091, 1658562, 1666033, 1673504, 1680975, 1688446, //13
1695917, 1703388, 1710859, 1718330, 1725801, 1733272, 1740743, 1748214, 1755685, 1763156, 1770627, 1778098, 1785569, //13
1793040, 1800511, 1807982, 1815453, 1822924, 1830395, 1837866, 1845337, 1852808, 1860279, 1867750, 1875221, 1882692, //13
1890163, 1897634, 1905105};                                                                                           //3

//static SDWORD CbRtab[256],CbGtab[256],CbBtab[256];
const SDWORD CbRtab[256]={
           0, -11058, -22116, -33174, -44232, -55290, -66348, -77406, -88464, -99522, -110580, -121638, -132696,     //13
 -143754, -154812, -165870, -176928, -187986, -199044, -210102, -221160, -232218, -243276, -254334, -265392,         //12
 -276450, -287508, -298566, -309624, -320682, -331740, -342798, -353856, -364914, -375972, -387030, -398088, -409146,//13
 -420204, -431262, -442320, -453378, -464436, -475494, -486552, -497610, -508668, -519726, -530784, -541842, -552900,//13
 -563958, -575016, -586074, -597132, -608190, -619248, -630306, -641364, -652422, -663480, -674538, -685596,         //12
 -696654, -707712, -718770, -729828, -740886, -751944, -763002, -774060, -785118, -796176, -807234, -818292,         //12
 -829350, -840408, -851466, -862524, -873582, -884640, -895698, -906756, -917814, -928872, -939930, -950988, -962046,//13
 -973104, -984162, -995220, -1006278, -1017336, -1028394, -1039452, -1050510, -1061568, -1072626, -1083684, -1094742,//12
 -1105800, -1116858, -1127916, -1138974, -1150032, -1161090, -1172148, -1183206, -1194264, -1205322, -1216380,       //11
 -1227438, -1238496, -1249554, -1260612, -1271670, -1282728, -1293786, -1304844, -1315902, -1326960, -1338018,       //11
 -1349076, -1360134, -1371192, -1382250, -1393308, -1404366, -1415424, -1426482, -1437540, -1448598, -1459656,       //11
 -1470714, -1481772, -1492830, -1503888, -1514946, -1526004, -1537062, -1548120, -1559178, -1570236, -1581294,       //11
 -1592352, -1603410, -1614468, -1625526, -1636584,                                                                   //5
 -1647642, -1658700, -1669758, -1680816, -1691874, -1702932, -1713990, -1725048, -1736106, -1747164,                 //10
 -1758222, -1769280, -1780338, -1791396, -1802454, -1813512, -1824570, -1835628, -1846686, -1857744, -1868802,       //11
 -1879860, -1890918, -1901976, -1913034, -1924092, -1935150, -1946208, -1957266, -1968324, -1979382, -1990440,       //11
 -2001498, -2012556, -2023614, -2034672, -2045730, -2056788, -2067846, -2078904, -2089962, -2101020, -2112078,       //11
 -2123136, -2134194, -2145252, -2156310, -2167368, -2178426, -2189484, -2200542, -2211600, -2222658, -2233716,       //11
 -2244774, -2255832, -2266890, -2277948, -2289006, -2300064, -2311122, -2322180, -2333238, -2344296, -2355354,       //11
 -2366412, -2377470, -2388528, -2399586, -2410644, -2421702, -2432760, -2443818, -2454876, -2465934, -2476992,       //11
 -2488050, -2499108, -2510166, -2521224, -2532282, -2543340, -2554398, -2565456, -2576514, -2587572, -2598630,       //11
 -2609688, -2620746, -2631804, -2642862, -2653920, -2664978, -2676036, -2687094, -2698152, -2709210, -2720268,       //11
 -2731326, -2742384, -2753442, -2764500, -2775558, -2786616, -2797674, -2808732, -2819790};                           //9

const SDWORD CbGtab[256]={
0, -21708, -43416, -65124, -86832, -108540, -130248, -151956, -173664, -195372, -217080, -238788,                    //12
-260496, -282204, -303912, -325620, -347328, -369036, -390744, -412452, -434160, -455868, -477576, -499284, -520992, //13
-542700, -564408, -586116, -607824, -629532, -651240, -672948, -694656, -716364, -738072, -759780, -781488, -803196, //13
-824904, -846612, -868320, -890028, -911736, -933444, -955152, -976860, -998568, -1020276, -1041984, -1063692,       //12
-1085400, -1107108, -1128816, -1150524, -1172232, -1193940, -1215648, -1237356, -1259064, -1280772, -1302480,        //11
-1324188, -1345896, -1367604, -1389312, -1411020, -1432728, -1454436, -1476144, -1497852, -1519560, -1541268,        //11
-1562976, -1584684, -1606392, -1628100, -1649808, -1671516, -1693224, -1714932, -1736640, -1758348, -1780056,        //11
-1801764, -1823472, -1845180, -1866888, -1888596, -1910304, -1932012, -1953720, -1975428, -1997136, -2018844,        //11
-2040552, -2062260, -2083968, -2105676, -2127384, -2149092, -2170800, -2192508, -2214216, -2235924, -2257632,        //11
-2279340, -2301048, -2322756, -2344464, -2366172, -2387880, -2409588, -2431296, -2453004, -2474712, -2496420,        //11
-2518128, -2539836, -2561544, -2583252, -2604960, -2626668, -2648376, -2670084, -2691792, -2713500, -2735208,        //11
-2756916, -2778624, -2800332, -2822040, -2843748, -2865456, -2887164, -2908872, -2930580, -2952288, -2973996,        //11
-2995704, -3017412, -3039120, -3060828, -3082536, -3104244, -3125952, -3147660, -3169368, -3191076, -3212784,        //11
-3234492, -3256200, -3277908, -3299616, -3321324, -3343032, -3364740, -3386448, -3408156, -3429864, -3451572,        //11
-3473280, -3494988, -3516696, -3538404, -3560112, -3581820, -3603528, -3625236, -3646944, -3668652, -3690360,        //11
-3712068, -3733776, -3755484, -3777192, -3798900, -3820608, -3842316, -3864024, -3885732, -3907440, -3929148,        //11
-3950856, -3972564, -3994272, -4015980, -4037688, -4059396, -4081104, -4102812, -4124520, -4146228, -4167936,        //11
-4189644, -4211352, -4233060, -4254768, -4276476, -4298184, -4319892, -4341600, -4363308, -4385016, -4406724,        //11
-4428432, -4450140, -4471848, -4493556, -4515264, -4536972, -4558680, -4580388, -4602096, -4623804, -4645512,        //11
-4667220, -4688928, -4710636, -4732344, -4754052, -4775760, -4797468, -4819176, -4840884, -4862592, -4884300,        //11
-4906008, -4927716, -4949424, -4971132, -4992840, -5014548, -5036256, -5057964, -5079672, -5101380, -5123088,        //11
-5144796, -5166504, -5188212, -5209920, -5231628, -5253336, -5275044, -5296752, -5318460, -5340168, -5361876,        //11
-5383584, -5405292, -5427000, -5448708, -5470416, -5492124, -5513832, -5535540};                                      //8


const SDWORD CbBtab[256]={
0, 32768, 65536, 98304, 131072, 163840, 196608, 229376, 262144, 294912, 327680, 360448, 393216, 425984,             //14
458752, 491520, 524288, 557056, 589824, 622592, 655360, 688128, 720896, 753664, 786432, 819200, 851968, 884736,     //14
917504, 950272, 983040, 1015808, 1048576, 1081344, 1114112, 1146880, 1179648, 1212416, 1245184, 1277952, 1310720,   //13
1343488, 1376256, 1409024, 1441792, 1474560, 1507328, 1540096, 1572864, 1605632, 1638400, 1671168, 1703936, 1736704,//13
1769472, 1802240, 1835008, 1867776, 1900544, 1933312, 1966080, 1998848, 2031616, 2064384, 2097152, 2129920, 2162688,//13
2195456, 2228224, 2260992, 2293760, 2326528, 2359296, 2392064, 2424832, 2457600, 2490368, 2523136, 2555904, 2588672,//13
2621440, 2654208, 2686976, 2719744, 2752512, 2785280, 2818048, 2850816, 2883584, 2916352, 2949120, 2981888, 3014656,//13
3047424, 3080192, 3112960, 3145728, 3178496, 3211264, 3244032, 3276800, 3309568, 3342336, 3375104, 3407872, 3440640,//13
3473408, 3506176, 3538944, 3571712, 3604480, 3637248, 3670016, 3702784, 3735552, 3768320, 3801088, 3833856, 3866624,//13
3899392, 3932160, 3964928, 3997696, 4030464, 4063232, 4096000, 4128768, 4161536, 4194304, 4227072, 4259840, 4292608,//13
4325376, 4358144, 4390912, 4423680, 4456448, 4489216, 4521984, 4554752, 4587520, 4620288, 4653056, 4685824, 4718592,//13
4751360, 4784128, 4816896, 4849664,                                                                                 //4
4882432, 4915200, 4947968, 4980736, 5013504, 5046272, 5079040, 5111808, 5144576, 5177344, 5210112, 5242880, 5275648,//13
5308416, 5341184, 5373952, 5406720, 5439488, 5472256, 5505024, 5537792, 5570560, 5603328, 5636096, 5668864, 5701632,//13
5734400, 5767168, 5799936, 5832704, 5865472, 5898240, 5931008, 5963776, 5996544, 6029312, 6062080, 6094848, 6127616,//13
6160384, 6193152, 6225920, 6258688, 6291456, 6324224, 6356992, 6389760, 6422528, 6455296, 6488064, 6520832, 6553600,//13
6586368, 6619136, 6651904, 6684672, 6717440, 6750208, 6782976, 6815744, 6848512, 6881280, 6914048, 6946816, 6979584,//13
7012352, 7045120, 7077888, 7110656, 7143424, 7176192, 7208960, 7241728, 7274496, 7307264, 7340032, 7372800, 7405568,//13
7438336, 7471104, 7503872, 7536640, 7569408, 7602176, 7634944, 7667712, 7700480, 7733248, 7766016, 7798784, 7831552,//13
7864320, 7897088, 7929856, 7962624, 7995392, 8028160, 8060928, 8093696, 8126464, 8159232, 8192000, 8224768, 8257536,//13
8290304, 8323072, 8355840};                                                                                          //3

//static SDWORD CrRtab[256],CrGtab[256],CrBtab[256];
const SDWORD CrRtab[256]={
           0, 32768, 65536, 98304, 131072, 163840, 196608, 229376, 262144, 294912, 327680, 360448, 393216, 425984,   //14
458752, 491520, 524288, 557056, 589824, 622592, 655360, 688128, 720896, 753664, 786432, 819200, 851968, 884736,      //14
917504, 950272, 983040, 1015808, 1048576, 1081344, 1114112, 1146880, 1179648, 1212416, 1245184, 1277952, 1310720,    //13
1343488, 1376256, 1409024, 1441792, 1474560, 1507328, 1540096, 1572864, 1605632, 1638400, 1671168, 1703936, 1736704, //13
1769472, 1802240, 1835008, 1867776, 1900544, 1933312, 1966080, 1998848, 2031616, 2064384, 2097152, 2129920, 2162688, //13
2195456, 2228224, 2260992, 2293760, 2326528, 2359296, 2392064, 2424832, 2457600, 2490368, 2523136, 2555904, 2588672, //13
2621440, 2654208, 2686976, 2719744, 2752512, 2785280, 2818048, 2850816, 2883584, 2916352, 2949120, 2981888, 3014656, //13
3047424, 3080192, 3112960, 3145728, 3178496, 3211264, 3244032, 3276800, 3309568, 3342336, 3375104, 3407872, 3440640, //13
3473408, 3506176, 3538944, 3571712, 3604480, 3637248, 3670016, 3702784, 3735552, 3768320, 3801088, 3833856, 3866624, //13
3899392, 3932160, 3964928, 3997696, 4030464, 4063232, 4096000, 4128768, 4161536, 4194304, 4227072, 4259840, 4292608, //13
4325376, 4358144, 4390912, 4423680, 4456448, 4489216, 4521984, 4554752, 4587520, 4620288, 4653056, 4685824, 4718592, //13
4751360, 4784128, 4816896, 4849664, 4882432,                                                                         //5
4915200, 4947968, 4980736, 5013504, 5046272, 5079040, 5111808, 5144576, 5177344, 5210112, 5242880, 5275648, 5308416, //13
5341184, 5373952, 5406720, 5439488, 5472256, 5505024, 5537792, 5570560, 5603328, 5636096, 5668864, 5701632, 5734400, //13
5767168, 5799936, 5832704, 5865472, 5898240, 5931008, 5963776, 5996544, 6029312, 6062080, 6094848, 6127616, 6160384, //13
6193152, 6225920, 6258688, 6291456, 6324224, 6356992, 6389760, 6422528, 6455296, 6488064, 6520832, 6553600, 6586368, //13
6619136, 6651904, 6684672, 6717440, 6750208, 6782976, 6815744, 6848512, 6881280, 6914048, 6946816, 6979584, 7012352, //13
7045120, 7077888, 7110656, 7143424, 7176192, 7208960, 7241728, 7274496, 7307264, 7340032, 7372800, 7405568, 7438336, //13
7471104, 7503872, 7536640, 7569408, 7602176, 7634944, 7667712, 7700480, 7733248, 7766016, 7798784, 7831552, 7864320, //13
7897088, 7929856, 7962624, 7995392, 8028160, 8060928, 8093696, 8126464, 8159232, 8192000, 8224768, 8257536, 8290304, //13
8323072, 8355840};                                                                                                    //2

const SDWORD CrGtab[256]={
0, -27438, -54876, -82314, -109752, -137190, -164628, -192066, -219504, -246942, -274380, -301818,                  //12
-329256, -356694, -384132, -411570, -439008, -466446, -493884, -521322, -548760, -576198, -603636, -631074, -658512,//13
-685950, -713388, -740826, -768264, -795702, -823140, -850578, -878016, -905454, -932892, -960330, -987768,         //12
-1015206, -1042644, -1070082, -1097520, -1124958, -1152396, -1179834, -1207272, -1234710, -1262148, -1289586,       //11
-1317024, -1344462, -1371900, -1399338, -1426776, -1454214, -1481652, -1509090, -1536528, -1563966, -1591404,       //11
-1618842, -1646280, -1673718, -1701156, -1728594, -1756032, -1783470, -1810908, -1838346, -1865784, -1893222,       //11
-1920660, -1948098, -1975536, -2002974, -2030412, -2057850, -2085288, -2112726, -2140164, -2167602, -2195040,       //11
-2222478, -2249916, -2277354, -2304792, -2332230, -2359668, -2387106, -2414544, -2441982, -2469420, -2496858,       //11
-2524296, -2551734, -2579172, -2606610, -2634048, -2661486, -2688924, -2716362, -2743800, -2771238, -2798676,       //11
-2826114, -2853552, -2880990, -2908428, -2935866, -2963304, -2990742, -3018180, -3045618, -3073056, -3100494,       //11
-3127932, -3155370, -3182808, -3210246, -3237684, -3265122, -3292560, -3319998, -3347436, -3374874, -3402312,       //11
-3429750, -3457188, -3484626, -3512064, -3539502, -3566940, -3594378, -3621816, -3649254, -3676692, -3704130,       //11
-3731568, -3759006, -3786444, -3813882, -3841320, -3868758, -3896196, -3923634, -3951072, -3978510, -4005948,       //11
-4033386, -4060824,                                                                                                 //2
-4088262, -4115700, -4143138, -4170576, -4198014, -4225452, -4252890, -4280328, -4307766, -4335204, -4362642,       //11
-4390080, -4417518, -4444956, -4472394, -4499832, -4527270, -4554708, -4582146, -4609584, -4637022, -4664460,       //11
-4691898, -4719336, -4746774, -4774212, -4801650, -4829088, -4856526, -4883964, -4911402, -4938840, -4966278,       //11
-4993716, -5021154, -5048592, -5076030, -5103468, -5130906, -5158344, -5185782, -5213220, -5240658, -5268096,       //11
-5295534, -5322972, -5350410, -5377848, -5405286, -5432724, -5460162, -5487600, -5515038, -5542476, -5569914,       //11
-5597352, -5624790, -5652228, -5679666, -5707104, -5734542, -5761980, -5789418, -5816856, -5844294, -5871732,       //11
-5899170, -5926608, -5954046, -5981484, -6008922, -6036360, -6063798, -6091236, -6118674, -6146112, -6173550,       //11
-6200988, -6228426, -6255864, -6283302, -6310740, -6338178, -6365616, -6393054, -6420492, -6447930, -6475368,       //11
-6502806, -6530244, -6557682, -6585120, -6612558, -6639996, -6667434, -6694872, -6722310, -6749748, -6777186,       //11
-6804624, -6832062, -6859500, -6886938, -6914376, -6941814, -6969252, -6996690};                                     //8

const SDWORD CrBtab[256]={
0, -5328, -10656, -15984, -21312, -26640, -31968, -37296, -42624, -47952, -53280, -58608, -63936, -69264,           //14
-74592, -79920, -85248, -90576, -95904, -101232, -106560, -111888, -117216, -122544, -127872, -133200, -138528,     //13
-143856, -149184, -154512, -159840, -165168, -170496, -175824, -181152, -186480, -191808, -197136, -202464, -207792,//13
-213120, -218448, -223776, -229104, -234432, -239760, -245088, -250416, -255744, -261072, -266400, -271728, -277056,//13
-282384, -287712, -293040, -298368, -303696, -309024, -314352, -319680, -325008, -330336, -335664, -340992, -346320,//13
-351648, -356976, -362304, -367632, -372960, -378288, -383616, -388944, -394272, -399600, -404928, -410256, -415584,//13
-420912, -426240, -431568, -436896, -442224, -447552, -452880, -458208, -463536, -468864, -474192, -479520, -484848,//13
-490176, -495504, -500832, -506160, -511488, -516816, -522144, -527472, -532800, -538128, -543456, -548784, -554112,//13
-559440, -564768, -570096, -575424, -580752, -586080, -591408, -596736, -602064, -607392, -612720, -618048, -623376,//13
-628704, -634032, -639360, -644688, -650016, -655344, -660672, -666000, -671328, -676656, -681984, -687312, -692640,//13
-697968, -703296, -708624, -713952, -719280, -724608, -729936, -735264, -740592, -745920, -751248, -756576, -761904,//13
-767232, -772560, -777888, -783216, -788544,                                                                        //5
-793872, -799200, -804528, -809856, -815184, -820512, -825840, -831168, -836496, -841824, -847152, -852480, -857808,//13
-863136, -868464, -873792, -879120, -884448, -889776, -895104, -900432, -905760, -911088, -916416, -921744, -927072,//13
-932400, -937728, -943056, -948384, -953712, -959040, -964368, -969696, -975024, -980352, -985680, -991008, -996336,//13
-1001664, -1006992, -1012320, -1017648, -1022976, -1028304, -1033632, -1038960, -1044288, -1049616, -1054944,       //11
-1060272, -1065600, -1070928, -1076256, -1081584, -1086912, -1092240, -1097568, -1102896, -1108224, -1113552,       //11
-1118880, -1124208, -1129536, -1134864, -1140192, -1145520, -1150848, -1156176, -1161504, -1166832, -1172160,       //11
-1177488, -1182816, -1188144, -1193472, -1198800, -1204128, -1209456, -1214784, -1220112, -1225440, -1230768,       //11
-1236096, -1241424, -1246752, -1252080, -1257408, -1262736, -1268064, -1273392, -1278720, -1284048, -1289376,       //11
-1294704, -1300032, -1305360, -1310688, -1316016, -1321344, -1326672, -1332000, -1337328, -1342656, -1347984,       //11
-1353312, -1358640};                                                                                                 //2

static float fdtbl_Y[64];		 
static float fdtbl_Cb[64]; //the same with the fdtbl_Cr[64]	

colorRGB *RGB_buffer; //image to be encoded
WORD Ximage,Yimage;// image dimensions divisible by 8
static SBYTE YDU[64]; // This is the Data Unit of Y after YCbCr->RGB transformation	 
static SBYTE CbDU[64];															
static SBYTE CrDU[64];															
static SWORD DU_DCT[64]; // Current DU (after DCT and quantization) which we'll zigzag
static SWORD DU[64]; //zigzag reordered DU which will be Huffman coded				 

extern char bufor_RAM_pliku_obrazka_format[];

extern void Delay_ms(int czas);

//extern const SPI2_TypeDef SPI_CS_tab[];
extern void Delay_us(int czas);
extern char format_obrazu;

uint32_t bazowy_adr_banku1_FSMC;

extern char przerwa_transmisji_flag;
 




//////////////////////////////////////////////
//END OF HEADERS
//////////////////////////////////////////////








// A BMP truecolor to JPEG encoder
// Copyright 1999 Cristi Cuturicu


void write_APP0info()
//Nothing to overwrite for APP0info
{
 writeword(APP0info.marker);
 writeword(APP0info.length);
 writebyte('J');writebyte('F');writebyte('I');writebyte('F');writebyte(0);
 writebyte(APP0info.versionhi);writebyte(APP0info.versionlo);
 writebyte(APP0info.xyunits);
 writeword(APP0info.xdensity);writeword(APP0info.ydensity);
 writebyte(APP0info.thumbnwidth);writebyte(APP0info.thumbnheight);
}

void write_SOF0info()
// We should overwrite width and height
{
 writeword(SOF0info.marker);
 writeword(SOF0info.length);
 writebyte(SOF0info.precision);
 writeword(SOF0info.height);writeword(SOF0info.width);
 writebyte(SOF0info.nrofcomponents);
 writebyte(SOF0info.IdY);writebyte(SOF0info.HVY);writebyte(SOF0info.QTY);
 writebyte(SOF0info.IdCb);writebyte(SOF0info.HVCb);writebyte(SOF0info.QTCb);
 writebyte(SOF0info.IdCr);writebyte(SOF0info.HVCr);writebyte(SOF0info.QTCr);
}

void write_DQTinfo()
{
 BYTE i;
 writeword(DQTinfo.marker);
 writeword(DQTinfo.length);
 writebyte(DQTinfo.QTYinfo);
 for (i=0;i<64;i++) 
 {
 	writebyte(DQTinfo.Ytable[i]);
 }
 writebyte(DQTinfo.QTCbinfo);
 for (i=0;i<64;i++) 
 {
 	writebyte(DQTinfo.Cbtable[i]);
 }
}

void set_quant_table(const BYTE *basic_table,BYTE scale_factor,BYTE *newtable)
// Set quantization table and zigzag reorder it
{
 BYTE i;
 long temp;
 for (i = 0; i < 64; i++) {
      temp = ((long) basic_table[i] * scale_factor + 50L) / 100L;
	/* limit the values to the valid range */
    if (temp <= 0L) temp = 1L;
    if (temp > 255L) temp = 255L; /* limit to baseline range if requested */
    newtable[zigzag[i]] = (WORD) temp;
			  }
}

void set_DQTinfo(BYTE quality_factor)
{
// BYTE scalefactor=50;// scalefactor controls the visual quality of the image
			 // the smaller is, the better image we'll get, and the smaller
			 // compression we'll achieve
BYTE scalefactor =quality_factor;
 DQTinfo.marker=0xFFDB;
 DQTinfo.length=132;
 DQTinfo.QTYinfo=0;
 DQTinfo.QTCbinfo=1;
 set_quant_table(std_luminance_qt,scalefactor,DQTinfo.Ytable);
 set_quant_table(std_chrominance_qt,scalefactor,DQTinfo.Cbtable);
}

void write_DHTinfo()
{
 BYTE i;
 writeword(DHTinfo.marker);
 writeword(DHTinfo.length);
 writebyte(DHTinfo.HTYDCinfo);
 for (i=0;i<16;i++)
 {
 	writebyte(DHTinfo.YDC_nrcodes[i]);
 }
 for (i=0;i<=11;i++)
 {
  	writebyte(DHTinfo.YDC_values[i]);
 }
 writebyte(DHTinfo.HTYACinfo);
 for (i=0;i<16;i++)  
 {
 	writebyte(DHTinfo.YAC_nrcodes[i]);
 }
 for (i=0;i<=161;i++) 
 {
 	writebyte(DHTinfo.YAC_values[i]);
 }
 writebyte(DHTinfo.HTCbDCinfo);
 for (i=0;i<16;i++)  
 {
 	writebyte(DHTinfo.CbDC_nrcodes[i]);
 }
 for (i=0;i<=11;i++)  
 {
 	writebyte(DHTinfo.CbDC_values[i]);
 }
 writebyte(DHTinfo.HTCbACinfo);
 for (i=0;i<16;i++)  
 {
 	writebyte(DHTinfo.CbAC_nrcodes[i]);
 }
 for (i=0;i<=161;i++) 
 {
 	writebyte(DHTinfo.CbAC_values[i]);
 }
}

void set_DHTinfo()
{
 BYTE i;
 DHTinfo.marker=0xFFC4;
 DHTinfo.length=0x01A2;
 DHTinfo.HTYDCinfo=0;
 for (i=0;i<16;i++)  
 {
 	DHTinfo.YDC_nrcodes[i]=std_dc_luminance_nrcodes[i+1];
 }
 for (i=0;i<=11;i++)  
 {
 	DHTinfo.YDC_values[i]=std_dc_luminance_values[i];
 }
 DHTinfo.HTYACinfo=0x10;
 for (i=0;i<16;i++)  
 {
 	DHTinfo.YAC_nrcodes[i]=std_ac_luminance_nrcodes[i+1];
 }
 for (i=0;i<=161;i++) 
 {
 	DHTinfo.YAC_values[i]=std_ac_luminance_values[i];
 }
 DHTinfo.HTCbDCinfo=1;
 for (i=0;i<16;i++)  
 {
 	DHTinfo.CbDC_nrcodes[i]=std_dc_chrominance_nrcodes[i+1];
 }
 for (i=0;i<=11;i++)  
 {
 	DHTinfo.CbDC_values[i]=std_dc_chrominance_values[i];
 }
 DHTinfo.HTCbACinfo=0x11;
 for (i=0;i<16;i++)  
 {
 	DHTinfo.CbAC_nrcodes[i]=std_ac_chrominance_nrcodes[i+1];
 }
 for (i=0;i<=161;i++) 
 {
 	DHTinfo.CbAC_values[i]=std_ac_chrominance_values[i];
 }
}

void write_SOSinfo()
//Nothing to overwrite for SOSinfo
{
 writeword(SOSinfo.marker);
 writeword(SOSinfo.length);
 writebyte(SOSinfo.nrofcomponents);
 writebyte(SOSinfo.IdY);writebyte(SOSinfo.HTY);
 writebyte(SOSinfo.IdCb);writebyte(SOSinfo.HTCb);
 writebyte(SOSinfo.IdCr);writebyte(SOSinfo.HTCr);
 writebyte(SOSinfo.Ss);writebyte(SOSinfo.Se);writebyte(SOSinfo.Bf);
}

void write_comment(BYTE *comment)
{
 WORD i,length;

 writeword(0xFFFE); //The COM marker
 length=(WORD)(strlen((const char *)comment));
 writeword(length+2);
 for (i=0;i<length;i++)
 {
  	writebyte(comment[i]);
 }
}

void writebits(bitstring bs)
// A portable version; it should be done in assembler
{
 WORD value;
 SBYTE posval;//bit position in the bitstring we read, should be<=15 and >=0
 value=bs.value;
 posval=(SBYTE)(bs.length-1);
 while (posval>=0)
  {
   if (value & mask[posval]) bytenew|=mask[bytepos];
   posval--;bytepos--;
   if (bytepos<0) { if (bytenew==0xFF) {writebyte(0xFF);writebyte(0);}
		     else {writebyte(bytenew);}
		    bytepos=7;bytenew=0;
		  }
  }
}

void compute_Huffman_table(const BYTE *nrcodes,const BYTE *std_table,bitstring *HT)
{
 BYTE k,j;
 BYTE pos_in_table;
 WORD codevalue;
 codevalue=0; pos_in_table=0;
 for (k=1;k<=16;k++)
   {
     for (j=1;j<=nrcodes[k];j++) 
	 {
	 			HT[std_table[pos_in_table]].value=codevalue;
				HT[std_table[pos_in_table]].length=k;
				pos_in_table++;
				codevalue++;
	 }
     codevalue*=(WORD)(2);
   }
}
void init_Huffman_tables()
{
 compute_Huffman_table(std_dc_luminance_nrcodes,std_dc_luminance_values,YDC_HT);
 compute_Huffman_table(std_dc_chrominance_nrcodes,std_dc_chrominance_values,CbDC_HT);
 compute_Huffman_table(std_ac_luminance_nrcodes,std_ac_luminance_values,YAC_HT);
 compute_Huffman_table(std_ac_chrominance_nrcodes,std_ac_chrominance_values,CbAC_HT);
}
//!!!! zamiana tablicy na kod
char set_numbers_category(SWORD wartosc_do_konwersji)
{
WORD maska=0x4000, wartosc;
char numer;

        wartosc =(WORD)abs(wartosc_do_konwersji);
        for (numer=15; numer>0; numer--)
        {
                if ((maska & wartosc) !=0) break;
                maska =(WORD)(maska >>1);
        }
        return numer;
}
//!!!! zamiana tablicy na kod
void set_numbers_bitcode(SWORD wartosc_do_konwersji)
{
WORD maska=0xC000, wartosc, tmp;
char numer;

        wartosc =(WORD)abs(wartosc_do_konwersji);
        for (numer=15; numer>0; numer--)
        {
                if ((maska & wartosc) !=0) break;
                maska =(WORD)((maska >>1)+0x8000);
        }
        konwersja[0].length =numer;
        if (wartosc_do_konwersji >=0)
        {
                konwersja[0].value=wartosc;
        }
        else
        {
                tmp =(WORD)~maska;
                wartosc =wartosc & tmp;
                wartosc =(WORD)(tmp -wartosc);
                konwersja[0].value=wartosc;
        }
}

/*
void precalculate_YCbCr_tables()
{
 WORD R,G,B;
 for (R=0;R<=255;R++) {YRtab[R]=(SDWORD)(65536*0.299+0.5)*R;
			   CbRtab[R]=(SDWORD)(65536*-0.16874+0.5)*R;
			   CrRtab[R]=(SDWORD)(32768)*R;
			  }
 for (G=0;G<=255;G++) {YGtab[G]=(SDWORD)(65536*0.587+0.5)*G;
			   CbGtab[G]=(SDWORD)(65536*-0.33126+0.5)*G;
			   CrGtab[G]=(SDWORD)(65536*-0.41869+0.5)*G;
			  }
 for (B=0;B<=255;B++) {YBtab[B]=(SDWORD)(65536*0.114+0.5)*B;
			   CbBtab[B]=(SDWORD)(32768)*B;
			   CrBtab[B]=(SDWORD)(65536*-0.08131+0.5)*B;
			  }
}
*/
// Using a bit modified form of the FDCT routine from IJG's C source:
// Forward DCT routine idea taken from Independent JPEG Group's C source for
// JPEG encoders/decoders

/* For float AA&N IDCT method, divisors are equal to quantization
   coefficients scaled by scalefactor[row]*scalefactor[col], where
   scalefactor[0] = 1
   scalefactor[k] = cos(k*PI/16) * sqrt(2)    for k=1..7
   We apply a further scale factor of 8.
   What's actually stored is 1/divisor so that the inner loop can
   use a multiplication rather than a division. */
void prepare_quant_tables()
{
 double aanscalefactor[8] = {1.0, 1.387039845, 1.306562965, 1.175875602,
			   1.0, 0.785694958, 0.541196100, 0.275899379};
 BYTE row, col;
 BYTE i = 0;
 for (row = 0; row < 8; row++)
 {
   for (col = 0; col < 8; col++)
     {
       fdtbl_Y[i] = (float) (1.0 / ((double) DQTinfo.Ytable[zigzag[i]] *
			  aanscalefactor[row] * aanscalefactor[col] * 8.0));
       fdtbl_Cb[i] = (float) (1.0 / ((double) DQTinfo.Cbtable[zigzag[i]] *
			  aanscalefactor[row] * aanscalefactor[col] * 8.0));

	   i++;
     }
 }
}

void fdct_and_quantization(SBYTE *data,float *fdtbl,SWORD *outdata)
{
  float tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7;
  float tmp10, tmp11, tmp12, tmp13;
  float z1, z2, z3, z4, z5, z11, z13;
  float *dataptr;
  float datafloat[64];
  float temp;
  SBYTE ctr;
  BYTE i;
  for (i=0;i<64;i++) 
  {
  	datafloat[i]=data[i];
  }

  /* Pass 1: process rows. */
  dataptr=datafloat;
  for (ctr = 7; ctr >= 0; ctr--) {
	tmp0 = dataptr[0] + dataptr[7];
    tmp7 = dataptr[0] - dataptr[7];
    tmp1 = dataptr[1] + dataptr[6];
    tmp6 = dataptr[1] - dataptr[6];
    tmp2 = dataptr[2] + dataptr[5];
    tmp5 = dataptr[2] - dataptr[5];
    tmp3 = dataptr[3] + dataptr[4];
    tmp4 = dataptr[3] - dataptr[4];

	/* Even part */

    tmp10 = tmp0 + tmp3;	/* phase 2 */
    tmp13 = tmp0 - tmp3;
    tmp11 = tmp1 + tmp2;
    tmp12 = tmp1 - tmp2;

    dataptr[0] = tmp10 + tmp11; /* phase 3 */
    dataptr[4] = tmp10 - tmp11;

    z1 = (tmp12 + tmp13) * ((float) 0.707106781); /* c4 */
	dataptr[2] = tmp13 + z1;	/* phase 5 */
    dataptr[6] = tmp13 - z1;

    /* Odd part */

    tmp10 = tmp4 + tmp5;	/* phase 2 */
    tmp11 = tmp5 + tmp6;
    tmp12 = tmp6 + tmp7;

	/* The rotator is modified from fig 4-8 to avoid extra negations. */
    z5 = (tmp10 - tmp12) * ((float) 0.382683433); /* c6 */
    z2 = ((float) 0.541196100) * tmp10 + z5; /* c2-c6 */
    z4 = ((float) 1.306562965) * tmp12 + z5; /* c2+c6 */
    z3 = tmp11 * ((float) 0.707106781); /* c4 */

    z11 = tmp7 + z3;		/* phase 5 */
    z13 = tmp7 - z3;

    dataptr[5] = z13 + z2;	/* phase 6 */
    dataptr[3] = z13 - z2;
	dataptr[1] = z11 + z4;
    dataptr[7] = z11 - z4;

    dataptr += 8;		/* advance pointer to next row */
  }

  /* Pass 2: process columns. */

  dataptr = datafloat;
  for (ctr = 7; ctr >= 0; ctr--) {
    tmp0 = dataptr[0] + dataptr[56];
    tmp7 = dataptr[0] - dataptr[56];
    tmp1 = dataptr[8] + dataptr[48];
    tmp6 = dataptr[8] - dataptr[48];
    tmp2 = dataptr[16] + dataptr[40];
    tmp5 = dataptr[16] - dataptr[40];
    tmp3 = dataptr[24] + dataptr[32];
    tmp4 = dataptr[24] - dataptr[32];

    /* Even part */

    tmp10 = tmp0 + tmp3;	/* phase 2 */
    tmp13 = tmp0 - tmp3;
    tmp11 = tmp1 + tmp2;
    tmp12 = tmp1 - tmp2;

    dataptr[0] = tmp10 + tmp11; /* phase 3 */
    dataptr[32] = tmp10 - tmp11;

	z1 = (tmp12 + tmp13) * ((float) 0.707106781); /* c4 */
    dataptr[16] = tmp13 + z1; /* phase 5 */
    dataptr[48] = tmp13 - z1;

    /* Odd part */

    tmp10 = tmp4 + tmp5;	/* phase 2 */
    tmp11 = tmp5 + tmp6;
    tmp12 = tmp6 + tmp7;

    /* The rotator is modified from fig 4-8 to avoid extra negations. */
	z5 = (tmp10 - tmp12) * ((float) 0.382683433); /* c6 */
    z2 = ((float) 0.541196100) * tmp10 + z5; /* c2-c6 */
    z4 = ((float) 1.306562965) * tmp12 + z5; /* c2+c6 */
    z3 = tmp11 * ((float) 0.707106781); /* c4 */

    z11 = tmp7 + z3;		/* phase 5 */
    z13 = tmp7 - z3;

    dataptr[40] = z13 + z2; /* phase 6 */
	dataptr[24] = z13 - z2;
    dataptr[8] = z11 + z4;
    dataptr[56] = z11 - z4;

    dataptr++;			/* advance pointer to next column */
  }

// Quantize/descale the coefficients, and store into output array
 for (i = 0; i < 64; i++) {
 /* Apply the quantization and scaling factor */
			   temp = datafloat[i] * fdtbl[i];
/* Round to nearest integer.
   Since C does not specify the direction of rounding for negative
   quotients, we have to force the dividend positive for portability.
   The maximum coefficient size is +-16K (for 12-bit data), so this
   code should work for either 16-bit or 32-bit ints.
*/
	   outdata[i] = (SWORD) ((SWORD)(temp + 16384.5) - 16384);
			  }
}

void process_DU(SBYTE *ComponentDU,float *fdtbl,SWORD *DC,
		bitstring *HTDC,bitstring *HTAC)
{
 bitstring EOB=HTAC[0x00];
 bitstring M16zeroes=HTAC[0xF0];
 BYTE i;
 BYTE startpos;
 BYTE end0pos;
 BYTE nrzeroes;
 BYTE nrmarker;
 SWORD Diff;

char num;//!!!

 fdct_and_quantization(ComponentDU,fdtbl,DU_DCT);
 //zigzag reorder
 for (i=0;i<=63;i++)
 {
  	DU[zigzag[i]]=DU_DCT[i];
 }
 Diff=(SWORD)(DU[0]-*DC);
 *DC=DU[0];
 //Encode DC
 if (Diff==0) writebits(HTDC[0]); //Diff might be 0
  else 
  {
        num =set_numbers_category(Diff);//!!!
        writebits(HTDC[num]);//!!!
        //!!!writebits(HTDC[category[Diff]]);
        set_numbers_bitcode(Diff);//!!!
        writebits(konwersja[0]);//!!!
		//writebits(bitcode[Diff]);
  }
 //Encode ACs
 for (end0pos=63;(end0pos>0)&&(DU[end0pos]==0);end0pos--) ;
 //end0pos = first element in reverse order !=0
 if (end0pos==0) {writebits(EOB);return;}

 i=1;
 while (i<=end0pos)
 {
   startpos=i;
   for (; (DU[i]==0)&&(i<=end0pos);i++) ;
   nrzeroes=(BYTE)(i-startpos);
   if (nrzeroes>=16) {
      for (nrmarker=1;nrmarker<=nrzeroes/16;nrmarker++)
	  {
	  	 writebits(M16zeroes);
	  }
      nrzeroes=(BYTE)(nrzeroes%16);
		     }

   num =set_numbers_category(DU[i]);//!!!
   writebits(HTAC[(nrzeroes*16)+num]);//!!!
   set_numbers_bitcode(DU[i]);//!!!
   writebits(konwersja[0]);//!!!
   //!!!writebits(bitcode[DU[i]]);
   //!!!writebits(HTAC[nrzeroes*16+category[DU[i]]]);writebits(bitcode[DU[i]]);
   i++;
 }
 if (end0pos!=63) writebits(EOB);
}
//--------------------------------------------------------------
//konwersja JPG pola 8 pikseli w kolejnych 8 liniach
void load_data_units_from_RGB_buffer(WORD pozycja_w_buf_16linii)
{
 BYTE x,y;
 BYTE pos=0;
 DWORD location;
 BYTE R,G,B;


 location=pozycja_w_buf_16linii;
 for (y=0;y<8;y++)
 {
  	//JPG_z_LCD_odczyt_bloku_RGB_pikseli(xpos, ypos+y, Ximage, &bufor_YUV_pola[0]);
   for (x=0;x<8;x++)
   {
	    //R=RGB_buffer[location].R;G=RGB_buffer[location].G;B=RGB_buffer[location].B;
			//R=JPG_z_LCD_odczyt_R_piksela_bloku(x, &bufor_YUV_pola[0]);
			//G=JPG_z_LCD_odczyt_G_piksela_bloku(x, &bufor_YUV_pola[0]);
			//B=JPG_z_LCD_odczyt_B_piksela_bloku(x, &bufor_YUV_pola[0]);
		if (parametry_jpg.piksel_PO6030_ile_bajtow ==2)
		{
			//R=b.7-b.3 1 bajtu; G=b.2-b.0 1 bajtu i b.7-b.5 2 bajtu; B=b.4-b.0 2 bajtu 
			
			R =0xF8 & bufor_RAM_pliku_obrazka_format[location+POCZATEK_BUFORU_16_LINII_OBRAZU];
			G =(0x07 & bufor_RAM_pliku_obrazka_format[location+POCZATEK_BUFORU_16_LINII_OBRAZU]) <<5;
			G =G + ((0xE0 & bufor_RAM_pliku_obrazka_format[location+1+POCZATEK_BUFORU_16_LINII_OBRAZU]) >>3);
			B =(0x1F & bufor_RAM_pliku_obrazka_format[location+1+POCZATEK_BUFORU_16_LINII_OBRAZU]) <<3;			
		}
		else
		{
			//R =G =B =8 bitw
			
			R =bufor_RAM_pliku_obrazka_format[location+POCZATEK_BUFORU_16_LINII_OBRAZU];
			G =bufor_RAM_pliku_obrazka_format[location+POCZATEK_BUFORU_16_LINII_OBRAZU];
			B =bufor_RAM_pliku_obrazka_format[location+POCZATEK_BUFORU_16_LINII_OBRAZU];
		}
	    YDU[pos]=(SBYTE)(Y(R,G,B));
	    CbDU[pos]=Cb(R,G,B);
	    CrDU[pos]=Cr(R,G,B);
	    location =location +parametry_jpg.piksel_PO6030_ile_bajtow;
		pos++;
   }
   location+=(Ximage-8) *parametry_jpg.piksel_PO6030_ile_bajtow;

 if (location >10240)
 {
 //location=0;
//return;
 }

 }
}
//-------------------------------------------------------------------
//pracujca w ptli procedura odczytu z buforu danych wejciowych w pamici Int RAM danych
//8 kolejnych linii obrazu i kodowania ich do JPG
void Kodowanie_JPG_Int_RAM(char *output_ptr, 		//pocztek buf.dla pliku wynikowego JPG 
						   int buf_output_rozmiar //rozmiar buforu dla pliku wynikowego JPG
						  )//wy: nie jawnie pozycja wskanika p_buf_wy do obliczenia dugoci pliku wynikowego JPG
{
SWORD DCY=0,DCCb=0,DCCr=0; //DC coefficients used for differential encoding
WORD xpos,ypos;

static char x,y, dane_piksela_tab[2], *p_dane_piksela_tab;
static DWORD location, location_bak;
BYTE R,G,B;
static BYTE pos;

static char *p_koniec_buforu_JPG, *p_dane_RAW;
//extern uint8_t bufor_RAM_pliku_obrazka_format[ROZMIAR_BUF_PLIKU_FORMAT_OBRAZ];

	GPIO_Linie_IO_Low(LINIA_LED_ZIELONY_WY);
	GPIO_Linie_IO_Low(LINIA_LED_CZERWONY_WY);

	//plik RAW dla utworzenia miniatury znajduje si w bufor_RAM_pliku_obrazka_format[]
	p_dane_RAW =&bufor_RAM_pliku_obrazka_format[0];
	p_koniec_buforu_JPG =(output_ptr +buf_output_rozmiar);

	location =0;
	p_dane_piksela_tab =&dane_piksela_tab[0];

 	for (ypos=0;ypos<Yimage;ypos+=(WORD)(8))
 	{
		location =0;
		location_bak =0;
  		for (xpos=0;xpos<Ximage;xpos+=(WORD)(8))
   		{
			//konwersja YUV kolejnego pola danych 8 pikseli x 8 kolejnych linii
			//i zapis do buforw YDU[], CbDU[, CrDU[]
			 location =location_bak;
			 pos =0;
			 for (y=0;y<8;y++)
 			 {
   				for (x=0;x<8;x++)
   				{
					if (parametry_jpg.piksel_PO6030_ile_bajtow ==2)
					{
						//2 bajty na piksel obrazu
						*p_dane_piksela_tab =*(__IO uint8_t*) (p_dane_RAW + 
						                                       location);
						location++;
						*(p_dane_piksela_tab+1) =*(__IO uint8_t*) (p_dane_RAW + 
						                                       location);
						location++;
						R =0xF8 & dane_piksela_tab[0];
						G =(0x07 & dane_piksela_tab[0]) <<5;
						G =G + ((0xE0 & dane_piksela_tab[1]) >>3);
						B =(0x1F & dane_piksela_tab[1]) <<3;			
					}
					else
					{
						//1 bajt na piksel obrazu
						*p_dane_piksela_tab =*(__IO uint8_t*) (p_dane_RAW + 
						                                       location);
						location++;
						R =dane_piksela_tab[0];
						G =dane_piksela_tab[0];
						B =dane_piksela_tab[0];
					}
				//	R=B=G=dane_piksela_tab[0];
	    			YDU[pos]=(SBYTE)(Y(R,G,B));
	    			CbDU[pos]=Cb(R,G,B);
	    			CrDU[pos]=Cr(R,G,B);
					pos++;
				}
				location=location +((Ximage-8) *parametry_jpg.piksel_PO6030_ile_bajtow);
			 }
			 location_bak=location_bak +(8 * parametry_jpg.piksel_PO6030_ile_bajtow);
			  
	   	 	 process_DU(YDU,fdtbl_Y,&DCY,YDC_HT,YAC_HT);
	    	 process_DU(CbDU,fdtbl_Cb,&DCCb,CbDC_HT,CbAC_HT);
	    	 process_DU(CrDU,fdtbl_Cb,&DCCr,CbDC_HT,CbAC_HT);
			//zabezpieczenie przed przepenieniem bufora dla pliku .JPG
			if (p_buf_wy > p_koniec_buforu_JPG)
			{
				//ustawienie wskanika na pocztku buforu bdzie oznaczao plik wyjciowy o zerowej dugoci
				GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
				GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
				p_buf_wy =output_ptr;
				return;
			} 
		}
		p_dane_RAW =p_dane_RAW + ((Ximage*8) *parametry_jpg.piksel_PO6030_ile_bajtow);
	}

	GPIO_Linie_IO_High(LINIA_LED_ZIELONY_WY);
	GPIO_Linie_IO_High(LINIA_LED_CZERWONY_WY);
}

//-------------------------------------------------------------------
void init_all(BYTE quality_factor)
{
 set_DQTinfo(quality_factor);
 set_DHTinfo();
 init_Huffman_tables();
// set_numbers_category_and_bitcode();
// precalculate_YCbCr_tables();
 prepare_quant_tables();
}
//-------------------------------------------------------------------------------------------------------------------
char* encode_image (char typ_kodowania_jpg ,//okrelenie rda danych do kodowania (Int RAM, Ext SRAM, SD)	w tej wersji zawsze KODOWANIE_JPG_Z_INT_RAM
					char *output_ptr, 		//pocztek buf.dla pliku wynikowego JPG (i danych wejciowych dla Int RAM)
					int buf_output_rozmiar, //rozmiar buforu dla pliku wynikowego JPG
					char quality_factor,    //wspczynnik jako/rozmiar pliku wynikowego
					int image_width, 		//szeroko w pikselach obrazka kodowanego
					int image_height,		//wysoko w liniach obrazka kodowanego
					char *p_sciezka_do_pliku)//nie uywany
					//wy: wskanik na pierwszy bajt za kocem pliku wynikowego (do obliczenia dugoci pliku wynikowego JPG)
{
 bitstring fillbits; //filling bitstring for the bit alignment of the EOI marker

    p_buf_wy =output_ptr;
 	Ximage=image_width;
 	Yimage=image_height;

	//inicjacja pl struktury Parametry_JPG	dla czstkowej konwersji RGB->YUV i JPG
    parametry_jpg.ile_pikseli_Hor_pola =8;
	parametry_jpg.ile_pikseli_Vert_pola =8;
	parametry_jpg.p_bufor_YUV_pola =&bufor_YUV_pola[0];
	parametry_jpg.numer_konwertowanego_pasa =0;
	parametry_jpg.numer_konwertowanego_pola =0;
	parametry_jpg.image_width =image_width;
	parametry_jpg.image_height =image_height;
	parametry_jpg.piksel_PO6030_ile_bajtow =2;

 //inicjacja struktury APP0info
    APP0info.marker =0xffe0;
    APP0info.length =16;
    APP0info.JFIFsignature[0]= 'J';
    APP0info.JFIFsignature[0]= 'F';
    APP0info.JFIFsignature[0]= 'I';
    APP0info.JFIFsignature[0]= 'F';
    APP0info.JFIFsignature[0]= '\0';
    APP0info.versionhi =1;
    APP0info.versionlo =1;
    APP0info.xyunits =0;
    APP0info.xdensity =1;
    APP0info.ydensity =1;
    APP0info.thumbnwidth =0;
    APP0info.thumbnheight =0;


	init_all((BYTE) quality_factor);
 	SOF0info.width=image_width;
	SOF0info.height=image_height;
	writeword(0xFFD8); //SOI
	write_APP0info();
	write_comment("ARS3 www.ars.info.pl www.arskam.com");
	write_DQTinfo();
	write_SOF0info();
	write_DHTinfo();
	write_SOSinfo();
	
	bytenew=0;bytepos=7;

	if (typ_kodowania_jpg ==KODOWANIE_JPG_Z_INT_RAM)
	{
		//kodowanie bezporednio z buforu w wewntrznej pamici RAM 
		Kodowanie_JPG_Int_RAM(output_ptr, buf_output_rozmiar);
	}

	//Do the bit alignment of the EOI marker
	if (bytepos>=0) {
			   fillbits.length=(BYTE)(bytepos+1);
			   fillbits.value=(WORD)((1<<(bytepos+1))-1);
			   writebits(fillbits);
			 }
	writeword(0xFFD9); //EOI
	
	
	return p_buf_wy;
}

