
#include "stm32f2xx_conf.h"
#include "diskio_stm32f2xx_SPI.h"
#include "diskio_stm32f2xx.h"
#include "integer.h"

void SPI_Config(void)
{
GPIO_InitTypeDef GPIO_InitStructure;
SPI_InitTypeDef  SPI_InitStructure;
BYTE dummyread;
//  NVIC_InitTypeDef NVIC_InitStructure;

  /* Peripheral Clock Enable -------------------------------------------------*/
  /* Enable the SPI clock */
  RCC_APB1PeriphClockCmd(SPI_SD_CLK, ENABLE);
  
  /* Enable GPIO clocks */
  RCC_AHB1PeriphClockCmd(SPI_SD_SCK_GPIO_CLK | SPI_SD_MISO_GPIO_CLK | SPI_SD_MOSI_GPIO_CLK, ENABLE);

  /* SPI GPIO Configuration --------------------------------------------------*/
  /* Connect SPI pins to AF5 */  
  GPIO_PinAFConfig(SPI_SD_SCK_GPIO_PORT, SPI_SD_SCK_SOURCE, SPI_SD_SCK_AF);
  GPIO_PinAFConfig(SPI_SD_MOSI_GPIO_PORT, SPI_SD_MOSI_SOURCE, SPI_SD_MOSI_AF);
  GPIO_PinAFConfig(SPI_SD_MISO_GPIO_PORT, SPI_SD_MISO_SOURCE, SPI_SD_MISO_AF);

  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;

  /* SPI SCK pin configuration */
  GPIO_InitStructure.GPIO_Pin = SPI_SD_SCK_PIN;
  GPIO_Init(SPI_SD_SCK_GPIO_PORT, &GPIO_InitStructure);

  /* SPI  MOSI pin configuration */
  GPIO_InitStructure.GPIO_Pin =  SPI_SD_MOSI_PIN;
  GPIO_Init(SPI_SD_MOSI_GPIO_PORT, &GPIO_InitStructure);

  /* SPI MISO configure as Input with internal pull-up */
  GPIO_InitStructure.GPIO_Pin =  SPI_SD_MISO_PIN;
  GPIO_Init(SPI_SD_MISO_GPIO_PORT, &GPIO_InitStructure);


//  GPIO_InitStructure.GPIO_Pin   = SPI_SD_MISO_PIN;
//  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN;
//  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_UP;
//  GPIO_Init(SPI_SD_MISO_GPIO_PORT, &GPIO_InitStructure);

 
  /* SPI configuration -------------------------------------------------------*/
  SPI_I2S_DeInit(SPI_SD_CARD);
  SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
  SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;
  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
  SPI_InitStructure.SPI_CRCPolynomial = 7;

  SPI_Init(SPI_SD_CARD, &SPI_InitStructure);
  SPI_CalculateCRC(SPI_SD_CARD, DISABLE);
  SPI_Cmd(SPI_SD_CARD, ENABLE);

  /* drain SPI */
  while (SPI_I2S_GetFlagStatus(SPI_SD_CARD, SPI_I2S_FLAG_TXE) == RESET) { ; }
  dummyread = SPI_I2S_ReceiveData(SPI_SD_CARD);

#ifdef STM32_SD_USE_DMA
	/* enable DMA clock */
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
#endif
  
}
//--------------------------------------------------------
//ustawienie niskiej lub wysokiej szybkoci interfejsu SPI
void interface_speed( enum speed_setting speed )
{ 
DWORD tmp;
#define SPI_BaudRatePrescaler_SPI_SD  SPI_BaudRatePrescaler_4

	tmp = SPI_SD_CARD->CR1;
	if ( speed == INTERFACE_SLOW ) {
		/* Set slow clock (100k-400k) */
		tmp = ( tmp | SPI_BaudRatePrescaler_256 );
	} else {
		/* Set fast clock (depends on the CSD) */
		tmp = ( tmp & ~SPI_BaudRatePrescaler_256 ) | SPI_BaudRatePrescaler_SPI_SD;
	}
	SPI_SD_CARD->CR1 = tmp;

}
//-------------------------------------------------------
//trnsmisja/odczyt 1 bajtu do/z karty MMC interfejsem SPI
BYTE stm32_spi_rw( BYTE out )
{
	/* Loop while DR register in not empty */
	/// not needed: while (SPI_I2S_GetFlagStatus(SPI_SD, SPI_I2S_FLAG_TXE) == RESET) { ; }

	/* Send byte through the SPI peripheral */
	SPI_I2S_SendData(SPI_SD_CARD, out);

	/* Wait to receive a byte */
	while (SPI_I2S_GetFlagStatus(SPI_SD_CARD, SPI_I2S_FLAG_RXNE) == RESET) { ; }

	/* Return the byte read from the SPI bus */
	return SPI_I2S_ReceiveData(SPI_SD_CARD);
}
//-------------------------------
//zwolnienie linii interfejsu SPI
void SPI_Zwolnienie_Linii_Interfejsu(void)
{
GPIO_InitTypeDef GPIO_InitStructure;

	SPI_I2S_DeInit(SPI_SD_CARD);
	SPI_Cmd(SPI_SD_CARD, DISABLE);
	RCC_APB2PeriphClockCmd(SPI_SD_CLK, DISABLE);

	/* All SPI-Pins to input with weak internal pull-downs */
	GPIO_InitStructure.GPIO_Pin   = SPI_SD_SCK_PIN;
	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_DOWN;
	GPIO_Init(SPI_SD_SCK_GPIO_PORT, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin   = SPI_SD_MISO_PIN;
	GPIO_Init(SPI_SD_MISO_GPIO_PORT, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin   = SPI_SD_MOSI_PIN;
	GPIO_Init(SPI_SD_MOSI_GPIO_PORT, &GPIO_InitStructure);

}
