/**
  ******************************************************************************
  * plik    diskio_stm32f2xx_SPI.h 
  * funkcja	plik nagwkowy procedur interfejsu SPI do komunikacji z kart MMC/SD 
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    24-02-2013
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __DISKIO_STM32F2XX_SPI_H
#define __DISKIO_STM32F2XX_SPI_H

#include "stm32f2xx_conf.h"
#include "integer.h"

#define SPI_SD_CARD						SPI2

#define SPI_SD_CLK                      RCC_APB1Periph_SPI2
#define SPI_SD_CLK_INIT                 RCC_APB1PeriphClockCmd
#define SPI_SD_IRQn                     SPI2_IRQn
#define SPI_SD_IRQHANDLER               SPI2_IRQHandler

#define SPI_SD_SCK_PIN                  GPIO_Pin_13
#define SPI_SD_SCK_GPIO_PORT            GPIOB
#define SPI_SD_SCK_GPIO_CLK             RCC_AHB1Periph_GPIOI
#define SPI_SD_SCK_SOURCE               GPIO_PinSource13
#define SPI_SD_SCK_AF                   GPIO_AF_SPI2

#define SPI_SD_MISO_PIN                 GPIO_Pin_14
#define SPI_SD_MISO_GPIO_PORT           GPIOB
#define SPI_SD_MISO_GPIO_CLK            RCC_AHB1Periph_GPIOB
#define SPI_SD_MISO_SOURCE              GPIO_PinSource14
#define SPI_SD_MISO_AF                  GPIO_AF_SPI2

#define SPI_SD_MOSI_PIN                 GPIO_Pin_15
#define SPI_SD_MOSI_GPIO_PORT           GPIOB
#define SPI_SD_MOSI_GPIO_CLK            RCC_AHB1Periph_GPIOB
#define SPI_SD_MOSI_SOURCE              GPIO_PinSource15
#define SPI_SD_MOSI_AF                  GPIO_AF_SPI2

void SPI_Config(void);
enum speed_setting { INTERFACE_SLOW, INTERFACE_FAST };
void interface_speed( enum speed_setting speed );
BYTE stm32_spi_rw( BYTE out );
void SPI_Zwolnienie_Linii_Interfejsu(void);

#endif

