/**
  ******************************************************************************
  * plik    Katalogi_SD.h
  * funkcja	plik nagwkowy procedur zwizanych z obsug katalogw i plikw karty SD	
  * autor 	ARIES Ryszard Szymaniak www.arskam.com
  * wersja 	1.0
  * data    25-02-2013
  * opis   	ARS3-MT9D111 sterownik ARS3 obsugujcy modu kamery MT9D111 firmy APTINA
  * 		STM32F217VGT
  ******************************************************************************
  */  
/* Define to prevent recursive inclusion ------------------------------------ */
#ifndef __KATALOGI_SD_H
#define __KATALOGI_SD_H

#include "stm32f2xx_conf.h"
#include "RTC_Zegar.h"
#include "stm32f2xx_rtc.h"
#include "EEPROM_procedury.h"
#include "Kamera.h"
#include "ff.h"
#include <stdio.h>


#define ROZMIAR_SCIEZKI_DOSTEPU_MAX		65
#define LIST_MAXLENFILENAME 12

#define SD_AKCJA_OTWORZ_DO_ODCZYTU		0
#define SD_AKCJA_OTWORZ_PRZESUN_CZYTAJ	1
#define SD_AKCJA_ZAMKNIJ				2
#define SD_AKCJA_OTWORZ_DO_ZAPISU		3
#define SD_AKCJA_OTWORZ_I_DOPISZ		4

#define ILOSC_ZDJEC_DZIENNIE_MAX		999

//identyfikatory etykiety pliku RAW
#define ETYKIETA_RAW_ETYKIETA_ROZMIAR		"e="
#define ETYKIETA_RAW_DANE_ROZMIAR			"s="
#define ETYKIETA_RAW_BAJTY_NA_PIKSEL		"b="
#define ETYKIETA_RAW_SZEROKOSC_OBRAZU		"w="
#define ETYKIETA_RAW_WYSOKOSC_OBRAZU		"h="
#define ETYKIETA_RAW_ZNAK_KONCA_DANYCH		"\r"
#define ETYKIETA_RAW_ROZMIAR_ETYKIETY_BAJTY	100

#define MINIATURA_SZEROKOSC					QQVGA_ILOSC_PIKSELI
#define MINIATURA_WYSOKOSC					QQVGA_ILOSC_LINII
#define MINIATURA_BAJTY_NA_PIKSEL			QQVGA_ILOSC_BAJTOW_NA_PIKSEL
#define MINIATURA_FORMAT_OBRAZU				NUMER_FORMATU_OZO_QQVGA_JPG

#define KATALOGI_WERYFIKACJA_OBECNOSCI	0

void Weryfikacja_Katalogow_Systemowych(uint8_t zadanie);
void Zapis_Zdjecia_do_Katalogu_Dnia(char *p_sciezka_do_pliku);
uint32_t Aktualny_katalog_dnia_Sciezka_Rozszerzenie(char *p_sciezka_do_pliku, char *p_rozszerzenie_pliku);

uint32_t SD_Card_dane_RW(uint8_t sd_akcja, uint8_t *p_bufor_pliku, uint32_t rozmiar_buforu, char *p_lista_sciezka, 
                                                                                              uint32_t przesuniecie);
char Odczyt_Statusu_Pliku_z_SD(char *p_sciezka_do_pliku);
bool Wyliczanie_kolejnych_pozycji_katalogu(char *p_sciezka_do_pliku, char *p_nazwa_pozycji, int16_t p_pozycja_wpisu_w_katalogu);
FRESULT Polecenie_C_pyt_ilosc_i_rozmiar_plikow_ilosc_podkat_w_kat(char *p_sciezka, int *p_ilosc_rozmiar_plikow_ilosc_podkat);

#endif




